diff --git a/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java b/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java
index 96f1468f1774286555906152238c65f21c4a08e9..46ddb544d08c1fc52cd597e88a63128e026e169e 100644
--- a/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java
+++ b/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java
@@ -736,9 +736,9 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
 
         mCMSCRLExtensions = new CMSCRLExtensions(this, config);
 
-        mExtendedNextUpdate = ((mUpdateSchema > 1 || (mEnableDailyUpdates && mExtendedTimeList)) && isDeltaCRLEnabled()) ?
-                                config.getBoolean(Constants.PR_EXTENDED_NEXT_UPDATE, true)
-                :
+        mExtendedNextUpdate =
+                ((mUpdateSchema > 1 || (mEnableDailyUpdates && mExtendedTimeList)) && isDeltaCRLEnabled()) ?
+                                config.getBoolean(Constants.PR_EXTENDED_NEXT_UPDATE, true) :
                                 false;
 
         // Get serial number ranges if any.
@@ -1166,7 +1166,9 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
                             IConfigStore crlSubStore = crlsSubStore.getSubStore(mId);
                             IConfigStore crlExtsSubStore =
                                     crlSubStore.getSubStore(ICertificateAuthority.PROP_CRLEXT_SUBSTORE);
-                            crlExtsSubStore = crlExtsSubStore.getSubStore(IssuingDistributionPointExtension.NAME);
+                            crlExtsSubStore =
+                                    crlExtsSubStore
+                                            .getSubStore(IssuingDistributionPointExtension.NAME);
 
                             if (crlExtsSubStore != null) {
                                 String val = "";
@@ -1599,8 +1601,8 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
                         }
                     }
                     if (t - mMinUpdateInterval > last) {
-                        if (mExtendedNextUpdate && (!fromLastUpdate) && (!(mEnableDailyUpdates && mExtendedTimeList))
-                                && (!delta) &&
+                        if (mExtendedNextUpdate
+                                && (!fromLastUpdate) && (!(mEnableDailyUpdates && mExtendedTimeList)) && (!delta) &&
                                 isDeltaEnabled && mUpdateSchema > 1) {
                             i += mUpdateSchema - ((i + m) % mUpdateSchema);
                         }
@@ -1686,8 +1688,8 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
             next = nextUpdate;
         }
 
-        CMS.debug("findNextUpdate:  " + ((new Date(next)).toString())
-                + ((fromLastUpdate) ? "  delay: " + (next - now) : ""));
+        CMS.debug("findNextUpdate:  "
+                + ((new Date(next)).toString()) + ((fromLastUpdate) ? "  delay: " + (next - now) : ""));
 
         return (fromLastUpdate) ? next - now : next;
     }
@@ -2231,7 +2233,7 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
     public boolean isDeltaCRLEnabled() {
         return (mAllowExtensions && mEnableCRLCache &&
                 mCMSCRLExtensions.isCRLExtensionEnabled(DeltaCRLIndicatorExtension.NAME) &&
-                mCMSCRLExtensions.isCRLExtensionEnabled(CRLNumberExtension.NAME) && 
+                mCMSCRLExtensions.isCRLExtensionEnabled(CRLNumberExtension.NAME) &&
                 mCMSCRLExtensions.isCRLExtensionEnabled(CRLReasonExtension.NAME));
     }
 
@@ -2339,8 +2341,8 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
                             Boolean.toString(isCRLCacheEnabled()),
                             Boolean.toString(mEnableCacheRecovery),
                             Boolean.toString(mCRLCacheIsCleared),
-                            "" + mCRLCerts.size() + "," + mRevokedCerts.size() + "," + mUnrevokedCerts.size() + ","
-                                    + mExpiredCerts.size() + ""
+                                    mCRLCerts.size() + "," + mRevokedCerts.size() + "," + mUnrevokedCerts.size()
+                                    + "," + mExpiredCerts.size() + ""
                     }
                    );
         mUpdatingCRL = CRL_UPDATE_STARTED;
@@ -2395,14 +2397,14 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
 
         mSplits[0] -= System.currentTimeMillis();
         @SuppressWarnings("unchecked")
-        Hashtable<BigInteger, RevokedCertificate> clonedRevokedCerts = (Hashtable<BigInteger, RevokedCertificate>) mRevokedCerts
-                .clone();
+        Hashtable<BigInteger, RevokedCertificate> clonedRevokedCerts =
+                (Hashtable<BigInteger, RevokedCertificate>) mRevokedCerts.clone();
         @SuppressWarnings("unchecked")
-        Hashtable<BigInteger, RevokedCertificate> clonedUnrevokedCerts = (Hashtable<BigInteger, RevokedCertificate>) mUnrevokedCerts
-                .clone();
+        Hashtable<BigInteger, RevokedCertificate> clonedUnrevokedCerts =
+                (Hashtable<BigInteger, RevokedCertificate>) mUnrevokedCerts.clone();
         @SuppressWarnings("unchecked")
-        Hashtable<BigInteger, RevokedCertificate> clonedExpiredCerts = (Hashtable<BigInteger, RevokedCertificate>) mExpiredCerts
-                .clone();
+        Hashtable<BigInteger, RevokedCertificate> clonedExpiredCerts =
+                (Hashtable<BigInteger, RevokedCertificate>) mExpiredCerts.clone();
 
         mSplits[0] += System.currentTimeMillis();
 
@@ -2441,8 +2443,8 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
             if (isDeltaCRLEnabled()) {
                 mSplits[1] -= System.currentTimeMillis();
                 @SuppressWarnings("unchecked")
-                Hashtable<BigInteger, RevokedCertificate> deltaCRLCerts = (Hashtable<BigInteger, RevokedCertificate>) clonedRevokedCerts
-                        .clone();
+                Hashtable<BigInteger, RevokedCertificate> deltaCRLCerts =
+                        (Hashtable<BigInteger, RevokedCertificate>) clonedRevokedCerts.clone();
 
                 deltaCRLCerts.putAll(clonedUnrevokedCerts);
                 if (mIncludeExpiredCertsOneExtraTime) {
@@ -2716,8 +2718,10 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
                         splitTimes += ",";
                     splitTimes += Long.toString(mSplits[i]);
                 }
-                splitTimes += "," + Long.toString(deltaTime) + "," + Long.toString(crlTime) + ","
-                        + Long.toString(totalTime) + ")";
+                splitTimes +=
+                        ","
+                                + Long.toString(deltaTime) + "," + Long.toString(crlTime) + ","
+                                + Long.toString(totalTime) + ")";
                 mLogger.log(ILogger.EV_AUDIT, ILogger.S_OTHER,
                             AuditFormat.LEVEL,
                             CMS.getLogMessage("CMSCORE_CA_CA_CRL_UPDATED"),
@@ -2817,7 +2821,6 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
      *  Suppress the warnings generated by adding to the session context   
      *   
      */
-    @SuppressWarnings("unchecked")
     protected void publishCRL(X509CRLImpl x509crl, boolean isDeltaCRL)
             throws EBaseException {
         SessionContext sc = SessionContext.getContext();
@@ -3014,7 +3017,8 @@ class CertRecProcessor implements IElementProcessor {
             return result;
         }
         boolean isIssuingDistPointExtEnabled = false;
-        isIssuingDistPointExtEnabled = exts.isCRLExtensionEnabled(IssuingDistributionPointExtension.NAME);
+        isIssuingDistPointExtEnabled =
+                exts.isCRLExtensionEnabled(IssuingDistributionPointExtension.NAME);
         if (isIssuingDistPointExtEnabled == false) {
             mIssuingDistPointEnabled = false;
             return false;
diff --git a/pki/base/ca/src/com/netscape/ca/CertificateAuthority.java b/pki/base/ca/src/com/netscape/ca/CertificateAuthority.java
index 0ae915d2f9b364c7431f041a03a0ed219140ccb6..dab9c069db82eeb324e1fc6646faeed35b6f8dc1 100644
--- a/pki/base/ca/src/com/netscape/ca/CertificateAuthority.java
+++ b/pki/base/ca/src/com/netscape/ca/CertificateAuthority.java
@@ -1561,12 +1561,13 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
             if (nc != null && nc.size() > 0) {
                 // Initialize Certificate Issued notification listener
 
-                String certificateIssuedListenerClassName = nc.getString("certificateIssuedListenerClassName",
-                        "com.netscape.cms.listeners.CertificateIssuedListener");
+                String certificateIssuedListenerClassName =
+                        nc.getString("certificateIssuedListenerClassName",
+                                "com.netscape.cms.listeners.CertificateIssuedListener");
 
                 try {
-                    mCertIssuedListener = (IRequestListener) Class.forName(certificateIssuedListenerClassName)
-                            .newInstance();
+                    mCertIssuedListener =
+                            (IRequestListener) Class.forName(certificateIssuedListenerClassName).newInstance();
                     mCertIssuedListener.init(this, nc);
                 } catch (Exception e1) {
                     log(ILogger.LL_FAILURE,
@@ -1575,12 +1576,13 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
 
                 // Initialize Revoke Request notification listener
 
-                String certificateRevokedListenerClassName = nc.getString("certificateIssuedListenerClassName",
-                        "com.netscape.cms.listeners.CertificateRevokedListener");
+                String certificateRevokedListenerClassName =
+                        nc.getString("certificateIssuedListenerClassName",
+                                "com.netscape.cms.listeners.CertificateRevokedListener");
 
                 try {
-                    mCertRevokedListener = (IRequestListener) Class.forName(certificateRevokedListenerClassName)
-                            .newInstance();
+                    mCertRevokedListener =
+                            (IRequestListener) Class.forName(certificateRevokedListenerClassName).newInstance();
                     mCertRevokedListener.init(this, nc);
                 } catch (Exception e1) {
                     log(ILogger.LL_FAILURE,
@@ -1590,8 +1592,9 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
                 // Initialize Request In Queue notification listener
                 IConfigStore rq = nc.getSubStore(PROP_REQ_IN_Q_SUBSTORE);
 
-                String requestInQListenerClassName = nc.getString("certificateIssuedListenerClassName",
-                        "com.netscape.cms.listeners.RequestInQListener");
+                String requestInQListenerClassName =
+                        nc.getString("certificateIssuedListenerClassName",
+                                "com.netscape.cms.listeners.RequestInQListener");
 
                 try {
                     mReqInQListener = (IRequestListener) Class.forName(requestInQListenerClassName).newInstance();
@@ -1701,6 +1704,7 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
                     "initializing crl issue point " + issuePointId);
             IConfigStore issuePointConfig = null;
             String issuePointClassName = null;
+            @SuppressWarnings("unchecked")
             Class<CRLIssuingPoint> issuePointClass = null;
             CRLIssuingPoint issuePoint = null;
 
diff --git a/pki/base/common/src/com/netscape/certsrv/base/MetaAttributeDef.java b/pki/base/common/src/com/netscape/certsrv/base/MetaAttributeDef.java
index 9450558c1d37932a38fd90537d11c211f87e7454..3a7bac97704c2f07852039eedf85cd2b74e3d437 100644
--- a/pki/base/common/src/com/netscape/certsrv/base/MetaAttributeDef.java
+++ b/pki/base/common/src/com/netscape/certsrv/base/MetaAttributeDef.java
@@ -34,7 +34,8 @@ public class MetaAttributeDef {
     private ObjectIdentifier mOid;
     private Class<?> mValueClass;
     private static Hashtable<String, MetaAttributeDef> mNameToAttrDef = new Hashtable<String, MetaAttributeDef>();
-    private static Hashtable<ObjectIdentifier, MetaAttributeDef> mOidToAttrDef = new Hashtable<ObjectIdentifier, MetaAttributeDef>();
+    private static Hashtable<ObjectIdentifier, MetaAttributeDef> mOidToAttrDef =
+            new Hashtable<ObjectIdentifier, MetaAttributeDef>();
 
     private MetaAttributeDef() {
     }
diff --git a/pki/base/common/src/com/netscape/certsrv/ocsp/IDefStore.java b/pki/base/common/src/com/netscape/certsrv/ocsp/IDefStore.java
index d971a71282d6ac27dd9ca999c822e6560e2c557f..7123de303ddfff3095e0e129e733c459f4f12517 100644
--- a/pki/base/common/src/com/netscape/certsrv/ocsp/IDefStore.java
+++ b/pki/base/common/src/com/netscape/certsrv/ocsp/IDefStore.java
@@ -110,7 +110,7 @@ public interface IDefStore extends IOCSPStore {
      * @return Enumeration a list of the CRL issuing points
      * @exception EBaseException occurs when no CRL issuing point exists
      */
-    public Enumeration searchAllCRLIssuingPointRecord(
+    public Enumeration<Object> searchAllCRLIssuingPointRecord(
             int maxSize)
             throws EBaseException;
 
diff --git a/pki/base/common/src/com/netscape/certsrv/policy/IGeneralNameUtil.java b/pki/base/common/src/com/netscape/certsrv/policy/IGeneralNameUtil.java
index 26bd8aeb70fdfcad833a10d1ec3332069171914e..102b25ccdde2f660d24aa3918aec13e82a22b1c0 100644
--- a/pki/base/common/src/com/netscape/certsrv/policy/IGeneralNameUtil.java
+++ b/pki/base/common/src/com/netscape/certsrv/policy/IGeneralNameUtil.java
@@ -54,7 +54,8 @@ public interface IGeneralNameUtil {
     /**
      * Default extended plugin info.
      */
-    public static String NUM_GENERALNAMES_INFO = "number;The total number of alternative names or identities permitted in the extension.";
+    public static String NUM_GENERALNAMES_INFO =
+            "number;The total number of alternative names or identities permitted in the extension.";
     public static String GENNAME_CHOICE_INFO =
             "choice(" +
                     IGeneralNameUtil.GENNAME_CHOICE_RFC822NAME + "," +
diff --git a/pki/base/common/src/com/netscape/certsrv/request/ARequestNotifier.java b/pki/base/common/src/com/netscape/certsrv/request/ARequestNotifier.java
index 124ca5590bbeadd14ee394e3f9244eb15de52c93..a50996f2b680b8d7b8415872501d304dea85177c 100644
--- a/pki/base/common/src/com/netscape/certsrv/request/ARequestNotifier.java
+++ b/pki/base/common/src/com/netscape/certsrv/request/ARequestNotifier.java
@@ -245,8 +245,8 @@ public class ARequestNotifier implements IRequestNotifier {
                     }
                     if (mRequests.size() < mMaxRequests) {
                         mRequests.addElement(r.getRequestId().toString());
-                        CMS.debug("getRequest  added " + r.getRequestType() + " request " + r.getRequestId().toString()
-                                +
+                        CMS.debug("getRequest  added "
+                                + r.getRequestType() + " request " + r.getRequestId().toString() +
                                   " to mRequests: " + mRequests.size() + " (" + mMaxRequests + ")");
                     } else {
                         break;
diff --git a/pki/base/common/src/com/netscape/certsrv/request/IRequest.java b/pki/base/common/src/com/netscape/certsrv/request/IRequest.java
index 8bd3048581c155b6ee902b19096968a03b2b23e8..19b830898d80bc8f312bd96c99246938bbc59d5d 100644
--- a/pki/base/common/src/com/netscape/certsrv/request/IRequest.java
+++ b/pki/base/common/src/com/netscape/certsrv/request/IRequest.java
@@ -355,7 +355,7 @@ public interface IRequest {
      *            the Hashtable contains an illegal key.
      * @return false if the key or hashtable keys are invalid
      */
-    public boolean setExtData(String key, Hashtable value);
+    public boolean setExtData(String key, Hashtable<String, String> value);
 
     /**
      * Checks whether the key is storing a simple String value, or a complex
@@ -391,14 +391,14 @@ public interface IRequest {
      * @return The hashtable value associated with the key. null if not found
      *         or if the key is associated with a string-value.
      */
-    public Hashtable getExtDataInHashtable(String key);
+    public Hashtable<String, String> getExtDataInHashtable(String key);
 
     /**
      * Returns all the keys stored in ExtData
      * 
      * @return Enumeration of all the keys.
      */
-    public Enumeration getExtDataKeys();
+    public Enumeration<String> getExtDataKeys();
 
     /**
      * Stores an array of Strings in ExtData.
@@ -652,7 +652,7 @@ public interface IRequest {
      * @param data A vector of Strings to store
      * @return False on key error or invalid data.
      */
-    public boolean setExtData(String key, Vector data);
+    public boolean setExtData(String key, Vector<?> data);
 
     /**
      * Returns a vector of strings for the key.
diff --git a/pki/base/common/src/com/netscape/certsrv/util/HttpInput.java b/pki/base/common/src/com/netscape/certsrv/util/HttpInput.java
index 51fefda57358f32c2fea95ea8df7375ee2f00fc6..fba601b6c61c580c10556de345ce520d8b51f48a 100644
--- a/pki/base/common/src/com/netscape/certsrv/util/HttpInput.java
+++ b/pki/base/common/src/com/netscape/certsrv/util/HttpInput.java
@@ -147,8 +147,8 @@ public class HttpInput {
                 i.equals("2048") || i.equals("4096")) {
             return i;
         }
-        throw new IOException("Invalid key length '" + i
-                + "'. Currently supported key lengths are 256, 512, 1024, 2048, 4096.");
+        throw new IOException("Invalid key length '"
+                + i + "'. Currently supported key lengths are 256, 512, 1024, 2048, 4096.");
     }
 
     public static String getKeySize(HttpServletRequest request, String name, String keyType)
@@ -159,8 +159,8 @@ public class HttpInput {
                     i.equals("2048") || i.equals("4096")) {
                 return i;
             } else {
-                throw new IOException("Invalid key length '" + i
-                        + "'. Currently supported RSA key lengths are 256, 512, 1024, 2048, 4096.");
+                throw new IOException("Invalid key length '"
+                        + i + "'. Currently supported RSA key lengths are 256, 512, 1024, 2048, 4096.");
             }
         }
         if (keyType.equals("ecc")) {
@@ -264,8 +264,8 @@ public class HttpInput {
         Pattern p = Pattern.compile("[A-Za-z0-9]+[A-Za-z0-9 -]*");
         Matcher m = p.matcher(v);
         if (!m.matches()) {
-            throw new IOException("Invalid characters found in Security Domain Name " + v
-                    + ". Valid characters are A-Z, a-z, 0-9, dash and space");
+            throw new IOException("Invalid characters found in Security Domain Name "
+                    + v + ". Valid characters are A-Z, a-z, 0-9, dash and space");
         }
         return v;
     }
diff --git a/pki/base/common/src/com/netscape/cms/authentication/DirBasedAuthentication.java b/pki/base/common/src/com/netscape/cms/authentication/DirBasedAuthentication.java
index 3120b9e23b8a8d44c8043750623bbc164a13f94f..da8d5bd5113c0890a30ac088916628b425ff98c9 100644
--- a/pki/base/common/src/com/netscape/cms/authentication/DirBasedAuthentication.java
+++ b/pki/base/common/src/com/netscape/cms/authentication/DirBasedAuthentication.java
@@ -120,10 +120,10 @@ public abstract class DirBasedAuthentication
             "E=$attr.mail, CN=$attr.cn, O=$dn.o, C=$dn.c";
 
     /* Vector of extendedPluginInfo strings */
-    protected static Vector mExtendedPluginInfo = null;
+    protected static Vector<String> mExtendedPluginInfo = null;
 
     static {
-        mExtendedPluginInfo = new Vector();
+        mExtendedPluginInfo = new Vector<String>();
         mExtendedPluginInfo.add(PROP_DNPATTERN + ";string;Template for cert" +
                 " Subject Name. ($dn.xxx - get value from user's LDAP " +
                 "DN.  $attr.yyy - get value from LDAP attributes in " +
@@ -570,8 +570,9 @@ public abstract class DirBasedAuthentication
         if (values == null)
             return;
 
-        Vector v = new Vector();
-        Enumeration e = values.getStringValues();
+        Vector<String> v = new Vector<String>();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> e = values.getStringValues();
 
         while (e.hasMoreElements()) {
             v.addElement(e.nextElement());
@@ -591,8 +592,9 @@ public abstract class DirBasedAuthentication
         if (values == null)
             return;
 
-        Vector v = new Vector();
-        Enumeration e = values.getByteValues();
+        Vector<byte[]> v = new Vector<byte[]>();
+        @SuppressWarnings("unchecked")
+        Enumeration<byte[]> e = values.getByteValues();
 
         while (e.hasMoreElements()) {
             v.addElement(e.nextElement());
diff --git a/pki/base/common/src/com/netscape/cms/authentication/FlatFileAuth.java b/pki/base/common/src/com/netscape/cms/authentication/FlatFileAuth.java
index 028cea37648ebec27a0cdd21a02fdd14e1242bfa..37e076d4a904d5c3fd2c61996f5179ed046a8d86 100644
--- a/pki/base/common/src/com/netscape/cms/authentication/FlatFileAuth.java
+++ b/pki/base/common/src/com/netscape/cms/authentication/FlatFileAuth.java
@@ -210,8 +210,8 @@ public class FlatFileAuth
             CMS.debug("FlatFileAuth: " + CMS.getLogMessage("CMS_AUTH_READ_ENTRIES", mFilename));
             // printAllEntries();
         } catch (IOException e) {
-            throw new EBaseException(mName + " authentication: Could not open file " + mFilename + "   ("
-                    + e.getMessage() + ")");
+            throw new EBaseException(mName
+                    + " authentication: Could not open file " + mFilename + "   (" + e.getMessage() + ")");
         } catch (java.lang.StringIndexOutOfBoundsException ee) {
             CMS.debug("FlatFileAuth: " + CMS.getLogMessage("OPERATION_ERROR", ee.toString()));
         }
diff --git a/pki/base/common/src/com/netscape/cms/authentication/SSLclientCertAuthentication.java b/pki/base/common/src/com/netscape/cms/authentication/SSLclientCertAuthentication.java
index 8a2a43ab4db9f30f316e18e149f3a3edc526a47b..35c23bd0f564022719dc93f69779e8f1281f3d10 100644
--- a/pki/base/common/src/com/netscape/cms/authentication/SSLclientCertAuthentication.java
+++ b/pki/base/common/src/com/netscape/cms/authentication/SSLclientCertAuthentication.java
@@ -332,7 +332,7 @@ public class SSLclientCertAuthentication implements IAuthManager,
     /**
      * Retrieves a list of names of the value parameter.
      */
-    public Enumeration getValueNames() {
+    public Enumeration<String> getValueNames() {
         return null;
     }
 
diff --git a/pki/base/common/src/com/netscape/cms/crl/CMSAuthorityKeyIdentifierExtension.java b/pki/base/common/src/com/netscape/cms/crl/CMSAuthorityKeyIdentifierExtension.java
index 96d73d4c411da19850b004868a5097eac4aa060c..26c8c1d0e22f0227cc67abca85e88dba2c19cdae 100644
--- a/pki/base/common/src/com/netscape/cms/crl/CMSAuthorityKeyIdentifierExtension.java
+++ b/pki/base/common/src/com/netscape/cms/crl/CMSAuthorityKeyIdentifierExtension.java
@@ -121,9 +121,10 @@ public class CMSAuthorityKeyIdentifierExtension
 
                 gNames.addElement(((ICertificateAuthority) crlIssuingPoint.getCertificateAuthority()).getX500Name());
 
-                authKeyIdExt = new AuthorityKeyIdentifierExtension(critical, null, gNames,
-                            new SerialNumber(((ICertificateAuthority) crlIssuingPoint.getCertificateAuthority())
-                                    .getCACert().getSerialNumber()));
+                authKeyIdExt =
+                        new AuthorityKeyIdentifierExtension(critical, null, gNames,
+                                new SerialNumber(((ICertificateAuthority) crlIssuingPoint.getCertificateAuthority())
+                                        .getCACert().getSerialNumber()));
             }
 
         } catch (IOException e) {
